#include "xsnmp.h"

#define Debug	(Flags & (PROG_DEBUG_FINGER | PROG_DEBUG))

char		*Fingerinfo=(char *)NULL;
int		Fingerbufsize;
char		*Fingerend;
XtInputId	Fingerid;
static int	fingersocket= -1;

XtInputCallbackProc x_readfinger(w, hptr) Widget w; HOSTENTRY *hptr; {
    register int	i;
    char		buffer[128];
    
    if(fingersocket == -1) return;

    /* read finger info. */
    if((i = read(fingersocket, buffer, sizeof(buffer)-1)) > 0) {
	do {
	    buffer[i] = '\0';
	    appendstr(buffer, &Fingerinfo, &Fingerbufsize, &Fingerend);
	} while((i = read(fingersocket, buffer, sizeof(buffer))) > 0);
    } else {
	fingersocket = -1;
	XtRemoveInput(Fingerid);
	disptext("Fingerinfo", Fingerinfo);
    }
}

void xt_finger() {
    register int	i;
    int			size;
    char		*hptr;
    HOSTENTRY		*hostptr;
    char		command[150];
    char		buffer[200];
    FILE		*file;
    char		*endptr;
    int			pipes[2];

    if((hostptr = widgettohost(Hostwidget)) == (HOSTENTRY *)NULL) {
	return;		/* internal error? */
    }

    hptr = fullhostname(hostptr->hl_name);

    sprintf(command, "@%s", hptr);

    if(pipe(pipes) < 0) return;
    
    if(Fingerinfo) {
	free(Fingerinfo);
	Fingerinfo = (char *)NULL;
	Fingerend = (char *)NULL;
	Fingerbufsize = 0;
    }

    switch(fork()) {
    case 0:			/* child */
	close(pipes[0]);	/* close read side */
	break;
    case -1:			/* error */
	return;
    default:			/* parent */
	close(pipes[1]);	/* close write side */
	fingersocket = pipes[0];
	Fingerid = XtAddInput(pipes[0], (XtPointer)XtInputReadMask
			      , (XtInputCallbackProc)x_readfinger
			      , (XtPointer)hostptr);
	return;
    }

    /* dup stdin and stdout */
    dup2(pipes[1], 1);
    dup2(pipes[1], 2);

    execlp("finger", "finger", command, (char *)NULL);
    perror("execlp");

    exit(0);			/* exit child */
}
