#include "xsnmp.h"

/*
 * Handle included network and host description files.
 */

typedef struct Includestr {
    char		*inc_filename;
    long		inc_position;
    struct Includestr	*inc_next;
}		INCLUDESTR;

INCLUDESTR	*Includes=(INCLUDESTR *)NULL;

typedef struct Incfilestr {
    char		*ifs_filename;
    struct Incfilestr	*ifs_next;
}		INCFILESTR;

INCFILESTR	*Incfiles=(INCFILESTR *)NULL;

pushinclude(file, name) FILE *file; char *name; {
    INCLUDESTR	*incptr;

    if((incptr = (INCLUDESTR *)malloc(sizeof(INCLUDESTR)))
       == (INCLUDESTR *)NULL) {
	dispnotice("Error", "Can't malloc memory! (pushinclude)");
	return(FALSE);
    }

    incptr->inc_filename = name;
    incptr->inc_position = ftell(file);
    incptr->inc_next = Includes;

    Includes = incptr;

    fclose(file);

    return(TRUE);
}

popinclude() {
    INCLUDESTR	*incptr;
    FILE	*file;

    if(! Includes) return(FALSE);

    /* close the current file and reopen the last one */
    if(Xsnmprcfile) fclose(Xsnmprcfile);

    if((file = fopen(Includes->inc_filename, "r")) != NULL) {
	fseek(file, Includes->inc_position, 0);
	Xsnmprcfile = file;
	Xsnmprcname = Includes->inc_filename;
    } else {
	dispnotice("Error", "Can't reopen include file!");
    }

    incptr = Includes->inc_next;
    free(Includes);
    Includes = incptr;

    return(TRUE);
}

doinclude(newfilename) char *newfilename; {
    FILE	*file;
    INCFILESTR	*iptr;
    char	*filename;

    if(Xsnmprcfile && !pushinclude(Xsnmprcfile, Xsnmprcname)) {
	return;
    }

    /* Now open the new file */
    if((file = fopen(newfilename, "r")) == (FILE *)NULL) {
	dispnotice("Error", "fopen failed for include file");
	return;
    }
    
    /* Add to include file list */
    if((iptr = (INCFILESTR *)malloc(sizeof(INCFILESTR)))
       == (INCFILESTR *)NULL) {
	dispnotice("Error", "can't malloc (doinclude)");
	return;
    }

    filename = cpystr(newfilename);

    iptr->ifs_filename = filename;
    iptr->ifs_next = Incfiles;
    Incfiles = iptr;

    /* And save all of the information */
    Xsnmprcname = filename;
    Xsnmprcfile = file;
/*    Xsnmprcp = (char *)NULL; */

    return;
}

/*
 * Are we inside an include file?
 */
in_include() {

    if(Includes)
	return(TRUE);
    else
	return(FALSE);
}

/*
 * Write out all include information to the 'rc file
 */
writeincludercinfo(file) FILE *file; {
    INCFILESTR	*iptr;
    
    for(iptr = Incfiles ; iptr ; iptr = iptr->ifs_next)
	fprintf(file, "include \"%s\"\n", iptr->ifs_filename);
}
